#!/usr/bin/python
# vim: set fileencoding=utf-8 expandtab shiftwidth=4 tabstop=4 softtabstop=4:

import pokereval
import random

p=pokereval.PokerEval()

n = 1000000

streets = { 3: 'Flop', 4: 'Turn', 5: 'River' }

print """
<style>
td { text-align: right; width: 90px; }
</style>
"""

for boardcards in [3, 4, 5]:
    handshit = {}

    for players in [2, 3, 4, 5, 6, 7, 8]:
        handshit[players] = {}
        for i in range(n):
            cards = random.sample(p.deck(), players*2+boardcards)
            pockets = []
            bestval = -1
            besthand = None
            for j in range(players):
                b = p.best("hi", cards[j*2:j*2+2]+cards[-boardcards:])
                if b[0] > bestval:
                    bestval = b[0]
                    besthand = b[1][0]
            if not besthand in handshit[players]:
                handshit[players][besthand] = 0
            handshit[players][besthand] += 1

    allhands = [
        'NoPair',
        'OnePair',
        'TwoPair',
        'Trips',
        'Straight',
        'Flush',
        'FlHouse',
        'Quads',
        'StFlush',
    ]

    print "<h2>%s</h2>" % streets[boardcards]
    print "<table border>"
    print "<tr><th></th>"
    for h in allhands:
        print "<th>%s</th>" % h
    print "</tr>"
    for players in [2, 3, 4, 5, 6, 7, 8]:
        print "<tr><td>%d players</td>" % players
        for h in allhands:
            print '<td>%.2f%%</td>' % (100.0*handshit[players].get(h, 0)/n)

    print "</table>"
